"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../index");
var UnknownProposal = /** @class */ (function (_super) {
    __extends(UnknownProposal, _super);
    function UnknownProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UnknownProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("Unknown Proposal ItemMap failed. " + (queriedId ? "Could not find Unknown Proposal with id '" + queriedId + "'" : ''));
            return null;
        }
        var unknownPluginState = index_1.UnknownPlugin.itemMap(context, item.scheme, queriedId);
        if (!unknownPluginState) {
            return null;
        }
        var unknownPlugin = new index_1.UnknownPlugin(context, unknownPluginState);
        var unknownPluginProposal = new UnknownProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, unknownPlugin, unknownPluginProposal, 'Unknown');
        if (!baseState) {
            return null;
        }
        return baseState;
    };
    UnknownProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        var result = this.context.getObservableObject(this.context, query, UnknownProposal.itemMap, this.id, apolloQueryOptions);
        return result;
    };
    return UnknownProposal;
}(index_1.Proposal));
exports.UnknownProposal = UnknownProposal;
var templateObject_1;
//# sourceMappingURL=unknownProposal.js.map