import BN from 'bn.js';
import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { IEntityRef } from '../../entity';
import { Address, Arc, DAO, IApolloQueryOptions, IProposalState, Operation, Proposal } from '../../index';
export interface IFundingRequestProposalState extends IProposalState {
    dao: IEntityRef<DAO>;
    beneficiary: Address;
    amount: BN;
    executed: Date;
    amountRedeemed: BN;
}
export declare class FundingRequestProposal extends Proposal<IFundingRequestProposalState> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query?: string): IFundingRequestProposalState | null;
    private static fragmentField;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<IFundingRequestProposalState>;
    /**
     * Redeem this proposal after it was accepted
     */
    redeem(): Operation<boolean>;
}
